#include <cstdio>
#include <algorithm>
using namespace std;

struct point{
    long long x;
    long long y;
    int ind;
    point(long long a=0, long long b=0){
        x=a;y=b;
    }
};

int n, ns, hull[100200], hs, ans[100200];
point p[100200], np[100200];
bool cantwin[100200];

inline bool cmp(point a, point b){
    return a.x>b.x || (a.x==b.x && a.y>b.y);
}

inline long long orient(point a, point b, point c){
    return a.y*b.x*c.x*c.y + a.x*b.x*b.y*c.y + a.x*a.y*b.y*c.x - a.x*a.y*b.x*c.y - a.y*b.x*b.y*c.x - a.x*b.y*c.x*c.y;
}

inline long long d(point a, point b){
    return (a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y);
}

inline bool cmp2(point a, point b){
    return orient(np[0], a, b)>0;
}

int main(){
    scanf("%d", &n);
    for (int i=0; i<n; ++i){
        scanf("%lld%lld", &p[i].x, &p[i].y);
        p[i].ind = i;
    }
    sort(p, p+n, cmp);

    np[ns++] = p[0];
    for (int i=1; i<n; ++i){
        if (p[i].x==p[i-1].x && p[i].y==p[i-1].y){
            cantwin[p[i-1].ind] = 1;
        }else{
            np[ns++] = p[i];
        }
    }

    n=ns;
    sort(np+1, np+n, cmp2);

    hull[0] = 0;
    hull[1] = 1;
    hs=2;
    for (int i=2; i<n; ++i){
        bool flag = 0;
        while (hs>1 && orient(np[hull[hs-2]], np[hull[hs-1]], np[i]) <= 0){
            if (orient(np[hull[hs-2]], np[hull[hs-1]], np[i]) == 0 && d(np[i], np[hull[hs-2]]) < d(np[hull[hs-1]], np[hull[hs-2]])){
                flag = 1;
                break;
            }else{
                --hs;
            }
        }
        if (!flag){
            hull[hs++]=i;
        }
    }

    int as = 0;
    ans[as++] = np[hull[0]].ind;
    for (int i=1; i<hs; ++i){
        if (np[hull[i]].y <= np[hull[i-1]].y){
            break;
        }else{
            ans[as++] = np[hull[i]].ind;
        }
    }

    sort(ans, ans+as);
    for (int i=0; i<as; ++i){
        if (!cantwin[ans[i]]){
            printf("%d ", ans[i]);
        }
    }
    printf("\n");
    return 0;
}
