#include <algorithm>
#include <cstdio>
#include <cstring>
#include <vector>

int n, k;

int bHeight[1 << 20];

int towers[1 << 17];
int sol[1 << 17];

// Persistent stack == graph
//
int lastNode;
int currentNode;
int nodeBuilding[1 << 20];
int parent[1 << 20];
std::vector<int> sons[1 << 20];
int depth[1 << 20];
int bonus[1 << 20];

int compute_depth(int v) {
    int sl = 0;
    for (int i = 0; i < (int) sons[v].size(); ++i) {
        sl = std::max(sl, compute_depth(sons[v][i]));
    }

    depth[v] = sl + 1;
    // if (v > 0) {
    //     printf("DEPTH of %d (%d) is %d\n", v - 1, bHeight[v - 1], depth[v]);
    // }
    return depth[v];
}

int main() {
    scanf("%d %d", &n, &k);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &bHeight[i]);
    }
    for (int i = 0; i < k; ++i) {
        scanf("%d", &towers[i]);
    }

    bHeight[n] = 1000000100;
    lastNode = 0;
    nodeBuilding[0] = n;
    parent[0] = -1;
    currentNode = 0;
    for (int i = 0; i < n; ++i) {
        // stack pop
        while (bHeight[nodeBuilding[currentNode]] < bHeight[i]) {
            // printf("%d pop %d\n", bHeight[i], bHeight[nodeBuilding[currentNode]]);
            currentNode = parent[currentNode];
        }
        
        // stack push
        int newNode = ++lastNode;
        // bonus is 1 if there is a taller tower to the left.
        // bonus[newNode] = (currentNode != 0);
        bonus[newNode] = 0;
        // printf("Put %d: %d at %d\n", bHeight[i], i, newNode);
        // if (bonus[newNode] == 0) {
        //     printf("bonus is 0 for %d %d at %d with parent %d\n",
        //            i, bHeight[i], newNode, currentNode);
        // }
        parent[newNode] = currentNode;
        sons[currentNode].push_back(newNode);
        nodeBuilding[newNode] = i;
        currentNode = newNode;
    }
    
    memset(depth, -1, sizeof(depth));
    compute_depth(0);

    std::vector< std::pair<int, int> > bHeightAndScore(n);
    // Loop from 1: skip persistent stack "root"
    for (int i = 1; i <= n; ++i) {
        bHeightAndScore[i - 1].first = bHeight[nodeBuilding[i]];
        bHeightAndScore[i - 1].second = depth[i] + bonus[i];
    }
    std::sort(bHeightAndScore.begin(), bHeightAndScore.end());
    for (int i = 1; i < n; ++i) {
        bHeightAndScore[i].second = std::max(
                bHeightAndScore[i].second, bHeightAndScore[i - 1].second);
    }
    // for (int i = 0; i < n; ++i) {
    //     printf("BH %d :: %d %d\n", i, bHeightAndScore[i].first, bHeightAndScore[i].second);
    // }
    
    std::vector< std::pair<int, int> > tHeightAndIdx(k);
    for (int i = 0; i < k; ++i) {
        tHeightAndIdx[i].first = towers[i];
        tHeightAndIdx[i].second = i;
    }
    std::sort(tHeightAndIdx.begin(), tHeightAndIdx.end());

    int bid = 0;
    for (int i = 0; i < k; ++i) {
        while (bid + 1 < n && bHeightAndScore[bid + 1].first < tHeightAndIdx[i].first) {
            ++bid;
        }
        // printf("%d %d tH %d %d bH %d %d\n", i, bid,
        //         tHeightAndIdx[i].first, tHeightAndIdx[i].second,
        //         bHeightAndScore[bid].first, bHeightAndScore[bid].second);
        if (bHeightAndScore[bid].first < tHeightAndIdx[i].first) {
            sol[tHeightAndIdx[i].second] = bHeightAndScore[bid].second;
        } else {
            sol[tHeightAndIdx[i].second] = 0;
        }
    }
    for (int i = 0; i < k; ++i) {
        printf("%d%c", sol[i], " \n"[i + 1 == k]);
    }
    return 0;
}
